#include <crypto/kem.h>

#define STR_AUX(a) #a
#define STR(a) STR_AUX(a)

NTL_CLIENT

int main()
{
	ostring txt = "jjj", K;
	int l;

#if !defined(Kdf)
#error "Error - Kdf not defined."
#endif

#if !defined(Hash)
#error "Error - Hash not defined."
#endif

#if (Hash == 1)
	SHA1 hash(20);
	Kdf kdf(hash);
#elif (Hash == 2)
	SHA256 hash(20);
	Kdf kdf(hash);
#elif (Hash == 3)
	MD5 hash(16);
	Kdf kdf(hash);
#else
#error "Error - Hash value not defined."
#endif

#if (GRP != 1 && GRP != 2 && GRP != 3) || !defined(GRP)
#error "Error - GRP not defined."
#endif

        // for reading group keys from file
#if (GRP == 1)
	ifstream ifile("grp.txt");
	modp_group grp(ifile);

	PSECKEM<modp_group> psec(kdf, grp, 128, 64);

#elif (GRP == 2)
	ifstream ifile("192.txt");

	ecmodp_group grp(ifile);
	PSECKEM<ecmodp_group> psec(kdf, grp, 128, 64);

#else
	ifstream ifile("163.txt");

	ecgf2_group grp(ifile);
	PSECKEM<ecgf2_group> psec(kdf, grp, 128, 64);

#endif

        if (!ifile) cout << " cannot open input file ";


	// for writing pseckem keys to file
	//ofstream fileo("psec.txt");
	//if (!fileo) cout << " cannot open psec output file ";
	//psec.writetofile(fileo);

#if defined(COMPRESS)
        grp.encoding_fmt = compressed_fmt;
#endif



	ofstream io(STR(DESC));
        ofstream trace(STR(TRACE));

	psec.PrettyPrint(io);
	psec.logfile = &trace;

	K = psec.encrypt(txt);

	if(K != psec.decrypt(txt, l))
		cout << " PSECkem failed " << endl;
	else
		cout << " PSECkem success " << endl;
}

